from tkinter import *
import math

# class
class CalculatorGUI:
    def __init__(self, root):
        self.expression = StringVar()
        self.root = root
        self.root.configure(background="#595e6d")
        self.root.title("ETC Calculator")
        self.root.geometry("325x250")
        self.root.resizable(0, 0)

        self.create_widgets()

    def create_widgets(self):

        expression_field = Entry(self.root, textvariable=self.expression,font=('Arial', 12, 'bold'))
        expression_field.grid(columnspan=4, ipadx=50)

        # This list contains the button labels
        buttons = [
            '7', '8', '9', '/',
            '4', '5', '6', '*',
            '1', '2', '3', '-',
            '0', '.'
        ]

        # Initializing the row and column values to place the buttons
        row_val = 2
        col_val = 0

        # For every button in the list, we place it in the proper row and column
        # you may rewrite the below, button by button without the for
        for button in buttons:
            Button(self.root, text=f' {button} ', fg='black', bg='#ced1dc', font=('Arial', 12, 'bold'),
                   command=lambda b=button: self.press(b), height=1, width=7).grid(row=row_val, column=col_val)

            # buttons are placed in table 4 columns b n Rows
            col_val += 1
            if col_val > 3:
                col_val = 0
                row_val += 1

        Button(self.root, text='Clear', fg='black', bg='#ddb1de', font=('Arial', 12, 'bold'),
               command=self.clear, height=1, width=7).grid(row=5, column=1)

# color values #RedGreenBlue, #ff0000 = red, #00ff00=green

        Button(self.root, text='C', fg='black', bg='#c3e1f1', font=('Arial', 12, 'bold'),
               command=self.clear_last, height=1, width=7).grid(row=5, column=2)

        Button(self.root, text="+", fg='black', bg='#ced1dc', font=('Arial', 12, 'bold'),
               command=lambda: self.press('+'), height=1, width=7).grid(row=5, column=3)

        Button(self.root, text=".", fg='black', bg='#ced1dc', font=('Arial', 12, 'bold'),
               command=lambda: self.press('.'), height=1, width=7).grid(row=6, column=0)

        Button(self.root, text='^', fg='black', bg='#ced1dc', font=('Arial', 12, 'bold'),
               command=lambda: self.press('**'), height=1, width=7).grid(row=6, column=1)

        Button(self.root, text='//', fg='black', bg='#ced1dc', font=('Arial', 12, 'bold'),
               command=lambda: self.press('//'), height=1, width=7).grid(row=6, column=2)

        Button(self.root, text=u"\u221A", fg='black', bg='#ced1dc', font=('Arial', 12, 'bold'),
               command=lambda: self.press('math.sqrt('), height=1, width=7).grid(row=7, column=0)

        Button(self.root, text=')', fg='black', bg='#ced1dc', font=('Arial', 12, 'bold'),
               command=lambda: self.press(')'), height=1, width=7).grid(row=7, column=1)

        Button(self.root, text=' = ', fg='black', bg='red', font=('Arial', 12, 'bold'),
               command=self.equal_press, height=1, width=7).grid(row=7, column=2)


    def press(self, num):
        self.expression.set(self.expression.get() + str(num))


    def equal_press(self):
        try:
            total = str(eval(self.expression.get()))
            self.expression.set(total)
        except:
            self.expression.set(" error ")


    def clear(self):
        self.expression.set("")


    def clear_last(self):
        l = len(self.expression.get())
        if l > 0:
            self.expression.set(self.expression.get()[:l - 1])
        else:
            self.expression.set("")


# Main
if __name__ == "__main__":
    root = Tk()
    calculator = CalculatorGUI(root)
    root.mainloop()
