# GUI registration form.

from tkinter import *
# The re library has tools for pattern matching
import re

class RegistrationForm:
    def __init__(self, root):
        self.root = root
        self.root.geometry("600x700")  # Increased the height to accommodate the error message label
        self.root.resizable(0, 0) # You cannot resize the window
        self.root.title('Registration form')

  # So far, we have created a blank window
  # Filling the window with widgets
        self.create_widgets()

    def create_widgets(self):
        label_0 = Label(self.root, text="Registration form", width=20, font=("bold", 20))
        label_0.place(x=90, y=60) # This is the text top left corner

        label_1 = Label(self.root, text="Full Name", width=20, font=("bold", 10))
        label_1.place(x=80, y=130)
        self.name = Entry(self.root)
        self.name.place(x=240, y=130)

        label_3 = Label(self.root, text="Email", width=20, font=("bold", 10))
        label_3.place(x=68, y=180)

        self.email = Entry(self.root)
        self.email.place(x=240, y=180)

        label_2 = Label(self.root, text="Mobile Number", width=20, font=("bold", 10))
        label_2.place(x=68, y=230)

        self.mobile = Entry(self.root)
        self.mobile.place(x=240, y=230)

        label_7 = Label(self.root, text="Comment", width=20, font=("bold", 10))
        label_7.place(x=68, y=280)

        # Added a Text widget for comments
        self.comment = Text(self.root, height=3, width=30, wrap="word")
        self.comment.place(x=240, y=280)

        label_4 = Label(self.root, text="Gender", width=20, font=("bold", 10))
        label_4.place(x=70, y=370)

        self.gender = IntVar()
        Radiobutton(self.root, text="Male", padx=5, variable=self.gender, value=1).place(x=235, y=370)
        Radiobutton(self.root, text="Female", padx=20, variable=self.gender, value=2).place(x=290, y=370)

        label_5 = Label(self.root, text="Country", width=20, font=("bold", 10))
        label_5.place(x=70, y=420)

        list_of_country = ['Lebanon', 'New Zealand', 'Iraq', 'US', 'UK', 'France', 'UAE']
        list_of_country = sorted(list_of_country)

        self.country = StringVar()
        droplist = OptionMenu(self.root, self.country, *list_of_country)
        droplist.config(width=15)
        self.country.set('Lebanon')  # Set Lebanon as the default country
        droplist.place(x=240, y=420)

        label_6 = Label(self.root, text="Language", width=20, font=('bold', 10))
        label_6.place(x=75, y=470)

        self.lang1 = IntVar()
        Checkbutton(self.root, text="English", variable=self.lang1).place(x=230, y=470)

        self.lang2 = IntVar()
        Checkbutton(self.root, text="German", variable=self.lang2).place(x=290, y=470)

        # Added a label for displaying error messages
        self.error_label = Label(self.root, text="Error Goes here", font=("bold", 10))
        self.error_label.place(x=180, y=520)

        Button(self.root, text='Submit', width=20, bg="black", fg='white', command=self.submit).place(x=180, y=550)



    def submit(self):
        # converting the data you filled in the window to variables
        full_name = self.name.get()
        email = self.email.get()
        mobile = self.mobile.get()
        gender = "Male" if self.gender.get() == 1 else "Female"
        country = self.country.get()
        lang1 = "English" if self.lang1.get() == 1 else ""
        lang2 = "German" if self.lang2.get() == 1 else ""
        comment = self.comment.get("1.0", "end-1c")  # Get the content of the Text widget

        error_message = self.validate_data(email)
        if error_message:
            self.error_label.config(text=error_message, fg="red")
            return
        else:
            self.error_label.config(text="", fg="red")

        # Clear the error message if no error
        self.error_label.config(text="")

        print('Full Name: ', full_name)
        print('Email: ', email)
        print('Mobile: ', mobile)
        print('Gender: ', gender, end="\t")
        print('Country: ', country)
        print('English: ', lang1, end="\t")
        print('German: ', lang2)
        print('Comment: ', comment)  # Added line for comments
        print('\n')

    def validate_data(self, email):
        # Validate email
        if not self.is_valid_email(email):
            return "Invalid email address. Please enter a valid email."

    def is_valid_email(self, email):
        # Creating a pattern made of three parts: local, @, domain
        regex = r'^\b[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Z|a-z]{2,}\b'

        # Use re.match to check if the email matches the pattern
        match = re.match(regex, email)
        return match

# Main
if __name__ == "__main__":
    root = Tk()
    registration_form = RegistrationForm(root)
    root.mainloop()

