import random
from tkinter import *
import winsound

class LotteryPickerGUI:
    def __init__(self, root):
        self.num_list = []
        self.num_dict = {}
        self.root = root
        self.root.configure(background="#595e6d")
        self.root.title("ETC Lottery Number Picker")
        self.root.geometry("850x200")
        self.create_widgets()

    def create_widgets(self):
        k = 0
        for i in range(1, 6):
            for j in range(1, 11):
                k += 1
                button_i_j = Button(self.root, text=str(k), fg='black', bg='#ced1dc', font=('Arial', 12, 'bold'),
                                     height=1, width=7)
                button_i_j.grid(row=i, column=j)
                self.num_list.append(k)
                self.num_dict[k] = (i, j)
                if k >= 42:
                    break

        generate = Button(self.root, text='Generate', fg='black', bg='#ced1dc', font=('Arial', 12, 'bold'),
                          command=self.gen_num, height=1, width=7)
        generate.grid(row=5, column=3)
        clear = Button(self.root, text='Clear', fg='black', bg='#ced1dc', font=('Arial', 12, 'bold'),
                       command=self.clear_numbers, height=1, width=7)
        clear.grid(row=5, column=4)

    def gen_num(self):
        self.create_widgets()
        winsound.Beep(150, 100)
        picks = random.sample(self.num_list, 6)
        print('Picks =', picks)
        print('Dictionary =', self.num_dict)

        for x in picks:
            ij = self.num_dict[x]
            print('Picked number: ', x, '\t', 'Position in form: ', ij)
            i = ij[0]
            j = ij[1]
            button_i_j = Button(self.root, text=str(x), fg='black', bg='#ff5555', font=('Arial', 12, 'bold'),
                                height=1, width=7)
            button_i_j.grid(row=i, column=j)

    def clear_numbers(self):
        self.create_widgets()
        winsound.Beep(50, 200)


if __name__ == "__main__":
    root = Tk()
    lottery_picker = LotteryPickerGUI(root)
    root.mainloop()

